require "gamedata/lua/common"
require "gamedata/lua/main/vip_sc2"
require "gamedata/lua/items/box"
require "gamedata/lua/stb/stb_opt"
function convert_price(price)
	if getSDKName() == "huanyi_app" then
		if (price==128) then
		    return 590
		elseif (price==198) then
		    return 890
		elseif (price==25) then
		    return 120
		elseif (price==30) then
		    return 150
		elseif (price==328) then
		    return 1490
		elseif (price==60) then
		    return 270
		elseif (price==6) then
		    return 30
		elseif (price==648) then
		    return 2990
		elseif (price==98) then
		    return 450
		end
	else
		return price
	end
end

function convert_usd(price) --us dollar
	if getSDKName() == "huanyi_app" then
		if (price==128) then
		    return 19.99
		elseif (price==198) then
		    return 29.99
		elseif (price==25) then
		    return 3.99
		elseif (price==30) then
		    return 4.99
		elseif (price==328) then
		    return 49.99
		elseif (price==60) then
		    return 8.99
		elseif (price==6) then
		    return 0.99
		elseif (price==648) then
		    return 99.99
		elseif (price==98) then
		    return 14.99
		end
	else
		return price
	end
end

function convert_price_with_currency(price)
	if getSDKName() == "huanyi_app" then
		return convert_price(price) .. " NTD"
	else
		return price .. ls('元')	end
end

function vip_sc_main(parentScene,info,acInfo)
	local MainScene = {}
	local price=info.recharge
	local gold=info.recharge*10
	local extraGold=info.additionalRecharge
	if acInfo then
		extraGold=math.floor(gold*acInfo.rate)
	end
	local curScene
    MainScene.handler = function(event)
        if event == "enter" then
        	-- OnEnter
			--MainScene.layer:scheduleUpdateWithPriorityLua(MainScene.updateScroll,0)
			curScene=CCDirector:sharedDirector():getRunningScene()
        end
    end
	local ptTouchBegan
	local scrollRect=CCRect(75,115,810,385)
	local rect=CCRect(0,0,390,150)
	local function onTouchBegan( x,y )
		if not parentScene.buy:isVisible() then
			return false
		end
		ptTouchBegan=ccp(x,y)
		return true
	end
	local function onTouchMoved( x,y )
		-- body
	end

	local function FreePay()
		local ret=net.rpc("vip.charge",price)
		if type(ret)=="table" then
			if _G.next(g_player_info.chargeInfo)==nil then
				addRedtip(GameMainScene.mainMainScene.gift)
				g_red_tip_first_charge=true
				if not g_localPlayer.goldEquipWizard then
					addArrows(GameMainScene.mainMainScene.gift)
				end
			end
			g_player_info.gold=ret.g
			g_player_info.chargedGold=ret.c
			g_player_info.chargeInfo[price]=ret.cnt
			MainScene.first:setVisible(false)
			parentScene.updateVipLevelInfo()
			popup_main(ls('充值成功'))
			if ret.zhizunkaTime then
				g_player_info.zhizunkaTime=ret.zhizunkaTime
			end
			if info.monthCard then--月卡
				g_player_info.yuekaDeadLine=ret.yuekaTime
				local str=""
				if g_player_info.yuekaDeadLine then
					str=getDayStr(g_player_info.yuekaDeadLine)
					str=str..ls('到期')				
				end
				if is7k7k() and g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,str),11))
				else
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc,str),11))
				end
			elseif info.honourableCard then
				if g_player_info.chargeInfo[price]==1 then--第一次充值至尊卡
					parentScene.initRecharge()
				else
					MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,extraGold),11))
				end
			else
				if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,extraGold),11))
				else
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc,extraGold),11))
				end
			end
		else
			popup_main(ls('出错'))
		end
	end

	MainScene.onTouchEnded = function ( x,y )
		if stb_opt.isStbOpt or math.pow(ptTouchBegan.x-x,2)+math.pow(ptTouchBegan.y-y,2)<math.pow(g_slidePixels,2) then
			local tp=curScene:convertToNodeSpace(ccp(x,y))
			if scrollRect:containsPoint(tp) then
				local tp=MainScene.layer:convertToNodeSpace(ccp(x,y))
				if rect:containsPoint(tp) then
					-- if CCApplication:sharedApplication():getTargetPlatform()==kTargetAndroid then
					-- 	return popup_main(ls('封测期间充值系统暂不开放，谢谢'),nil,8)
					-- end
					if JavaGetAppName and JavaGetAppName()=="com.morlia.hzmc" then
						if webview then
						  local url="http://login.mydearlord.morlia.com//cb/mc/select.php"
						  url=url .. "?uid=" .. g_player_info.utid
						  url=url .. "&svrId=" .. g_svrId
						  url=url .. "&price=" .. price
						  url=url .. "&name=" .. g_player_info.name
						  local md5 = require "gamedata/lua/net/md5"
						  local hash=md5.sumhexa("login_main".. g_player_info.utid .. g_svrId)
						  --MyMessageBox(hash)
						  url=url .. "&hash=" .. hash
						  local node=webview(url)
						  local size = CCEGLView:sharedOpenGLView():getVisibleSize()
						  local layer=CCLayerColor:create(ccc4(255,255,255,255),size.width,size.height)
						  layer:setTouchEnabled(true)
						  layer:registerScriptTouchHandler(function() return true end,false,-150,true)
						  local w=(size.width-960)/2
						  node:setPositionX(-w)
						  node:setContentSize(CCSize(size.width-125,size.height))
						  node:addChild(layer)
						  local item1 = CCMenuItemFont:create("close")
						  item1:setColor(ccc3(0,0,0))
						  item1:registerScriptTapHandler(function()
							node:removeFromParentAndCleanup(true)
						  end) --注册触摸事件
						  local menu=CCMenu:create()
						  menu:addChild(item1)
						  menu:setAnchorPoint(ccp(-1,-1))
						  menu:setPosition(ccp(size.width-50,size.height-50))
						  menu:setTouchPriority(-150)
						  node:addChild(menu,200)
						  node:setZOrder(99999)
						  CCDirector:sharedDirector():getRunningScene():addChild(node)
						else
						  MyMessageBox("webview nil")
						end
						return
					end

					local pName=price *10 .. ls('元宝')					if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
						pName=price *10 .. "yuanbao"
					end
                    if g_is185sy then
						pName=price *10*g_chongzhiMulti .. ls('元宝')
					end
					local check_str=""
					if info.monthCard then--月卡
						pName=ls('月卡')						if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
							pName="yueka"
						end
						check_str=ls('确定充值%s购买月卡？',convert_price_with_currency(price))					elseif info.honourableCard and (g_player_info.chargeInfo[price]==nil or g_player_info.chargeInfo[price]==0)then
						check_str=ls('确定充值%s购买至尊卡？',convert_price_with_currency(price))						pName=ls('至尊卡')						if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
							pName="zhizunka"
						end
					else
						check_str=ls('确定充值')..convert_price_with_currency(price).."？"
					end
					coFunc(function ()

						local platform=CCApplication:sharedApplication():getTargetPlatform()

						local sdkName=getSDKName()
						if platform==kTargetWindows or sdkName==nil or sdkName=="test" or sdkName =="IOS" then --测试服，元宝随意冲
							FreePay()
						elseif sdkName == "weilan" or sdkName == "appstore" or sdkName == "huanyi_app" or sdkName == "appttbsg" or getSDKName()=="gjsg" then
							local rate = 1

							local appName = "unknow"

							xpcall(function()
								appName = lua_GetAppName()
							end,function(err)
								print(err)
							end)

							local ret=net.rpc("vip.getOrderId",price,g_extraOrderArg,appName)

							cclog("order_id:",ret or "nil")
							if type(ret)=="string" then
								if ret=="cnt" or ret=="failed" or ret=="time" then
									MyMessageBox(ls('获取信息失败，请重新尝试。'))
								else
									local info = {
										Order_Id=ret,
										Product_Price=tostring(convert_price(price*rate)),
										Transaction_Num="10",
										Product_Id=tostring(price),
										Product_Name=pName,
										Role_Id=tostring(g_player_info.utid),
										Role_Name=g_player_info.name,
										Notify_Url="",
										EXT="",
										Server_Id=tostring(0),
										Product_Count="1",
										Role_Grade=tostring(g_player_info.level),
										Role_Balance=tostring(g_player_info.gold)
									   }
									if g_svrId>10000 and g_svrId < 20000 then
										if price==25 then
											info.Product_Id="com.shenxiuinfo.sg.g250"
										elseif price==60 then
											info.Product_Id="com.shenxiuinfo.sg.g600"
										end
									end
									--安卓支付
									if sdkName == "huanyi_app" and kTargetAndroid==platform then
										info.Product_Id = "com.morlia.hzsgz.g"..convert_price(price*rate)
									end
									cclog("try to record pay log")
									td_chargerequest(info.Order_Id,info.Product_Name,convert_usd(price),"USD",price*10,"DEFAULT")
									paySDK(info)
								end
							end
						elseif kTargetAndroid==platform or kTargetIphone==platform or kTargetIpad==platform then
							cclog("vip_sc:kTargetAndroid")
							if g_anysdk_agent then
								cclog("g_anysdk_agent")
								local iap_plugin_maps = g_anysdk_agent:getIAPPlugin()
								local function onResult( code, msg, info )   --code: pay result code, msg: par result message, info: product info.
								   cclog("pay result----")
									if msg then
										cclog("pay result----:" ..msg)
									end
								   if code == PayResultCode.kPaySuccess  then
									   cclog("PayResultCode.kPaySuccess")
										--popup_main("充值成功！")
									elseif code == PayResultCode.kPayNowPaying then
										cclog("PayResultCode.kPayNowPaying")
										ProtocolIAP:resetPayState()
								   end
							   end
							   for key, value in pairs(iap_plugin_maps) do
								   cclog("key:" .. key)
								   cclog("value: " .. type(value))
								   value:setResultListener(onResult)
							   end
								local pId=tostring(price)
								if "000016"==g_anysdk_agent:getChannelId() then --联想
									--pId="3647"
									local  t = {}
									t[6]   = 67132
									t[25]  = 67130
									t[30]  = 67133
									t[60]  = 67131
									t[98]  = 67134
									t[128] = 67135
									t[198] = 67136
									t[328] = 67137
									t[648] = 67138
									pId = tostring(t[price])
								elseif "000066" == g_anysdk_agent:getChannelId() or "800002" == g_anysdk_agent:getChannelId() then  --小米
									local t = {}
									t[6]   = "tt1013"
									t[25]  = "tt1012"
									t[30]  = "tt1014"
									t[60]  = "tt1011"
									t[98]  = "tt1015"
									t[128] = "tt1016"
									t[198] = "tt1017"
									t[328] = "tt1018"
									t[648] = "tt1019"
									pId    = t[price]
								elseif "000009"==g_anysdk_agent:getChannelId() or "000078"==g_anysdk_agent:getChannelId() then --应用汇/酷派
									pId="1"
								elseif "160002"==g_anysdk_agent:getChannelId() then --爱贝
									local t={}
									t[6]=3
									t[60]=2
									t[25]=1
									t[198]=7
									t[128]=6
									t[98]=5
									t[30]=4
									t[648]=9
									t[328]=8
									pId=tostring(t[price])
								elseif "160204"==g_anysdk_agent:getChannelId() then --爱贝IOS(sf)
									local t = {}
									t[6]=1
									t[25]=2
									t[30]=3
									t[60]=4
									t[98]=5
									t[128]=6
									t[198]=7
									t[328]=8
									t[648]=9
									pId=tostring(t[price])
								end
								local info = {
								   Product_Price=tostring(price),
								   Product_Id=pId,
								   Product_Name=pName,
								   Server_Id=tostring(g_svrId),
								   Product_Count="1",
								   Role_Id=tostring(g_player_info.utid),
								   Role_Name=g_player_info.name,
								   Role_Grade=tostring(g_player_info.level),
								   Role_Balance=tostring(g_player_info.gold)
							   }
								if g_anysdk_agent:getChannelId()=="001201" or g_anysdk_agent:getChannelId()=="500035" then -- 叉叉
									info.EXT = ""
								elseif g_anysdk_agent:getChannelId()=="111226" then
									local chongchongIds={}
									chongchongIds["6"]=101444
									chongchongIds["25"]=101416
									chongchongIds["30"]=101417
									chongchongIds["60"]=101418
									chongchongIds["98"]=101419
									chongchongIds["128"]=101420
									chongchongIds["198"]=101421
									chongchongIds["328"]=101422
									chongchongIds["648"]=101445
									info.Product_Id=chongchongIds[tostring(price)]
								end
								for key, value in pairs(iap_plugin_maps) do
									cclog("key:" .. key)
									value:payForProduct(info)
									break
								end
							elseif g_initSDK then
								cclog("g_initSDK")
								local ret=net.rpc("vip.getOrderId",price)
								cclog("order_id:",ret or "nil")
								if type(ret)=="string" then
									if ret=="cnt" or ret=="failed" or ret=="time" then
										MyMessageBox(ls('获取信息失败，请重新尝试。'))
									else
										--MyMessageBox(ret)
										local payurl=""
										local rate=1
										local sdkName=getSDKName()
										if sdkName=="QIHOO_SDK" then
											rate=100
											payurl="http://cb.ttbsg.bwbbw.com/cb/qihoo/pay_callback.php"
										elseif sdkName=="UC_SDK" then
											rate=1
											payurl="http://cb.ttbsg.bwbbw.com/cb/uc/PayCallbackServer.php"
										elseif sdkName=="LETVSDK" then
											payurl="http://cb.ttbsg.bwbbw.com/cb/leshi/pay.php"
										elseif sdkName == "KUAIYONGSDK" then
											payurl="http://cb.ttbsg.bwbbw.com/cb/kuaiyong/pay.php"
										end

										local info = {
											Order_Id=ret,
											Product_Price=tostring(price*rate),
											Transaction_Num="10",
											Product_Id=tostring(price),
											Product_Name=pName,
											Role_Id=tostring(g_player_info.utid),
											Role_Name=g_player_info.name,
											Notify_Url=payurl,
											EXT="",
											Server_Id=tostring(0),
											Product_Count="1",
											Role_Grade=tostring(g_player_info.level),
											Role_Balance=tostring(g_player_info.gold)
									   }
										if sdkName == "HUAWEISDK" then --华为这个是作为requestId的，要求必须不同，所以使用orderid的时间部分加上uid
											info.Role_Id = string.sub(info.Order_Id,1,14)..info.Role_Id
										elseif sdkName == "MGSDK" or sdkName == "LLSDK" or sdkName == "MOLISDK" then
											info.EXT=tostring(g_svrId)
							            elseif sdkName == "NEWUCSDK" then
											local uu = json.decode(g_userJson)
											cclog("-------------accoountId",uu.accountId)
											info.Role_Name = tostring(uu.accountId)
											info.Product_Id = tostring(uu.accountId)
										end
										if sdkName == "LQLQSSDK" then
											info.Role_Id = tostring(g_svrId)
										end
										td_chargerequest(info.Order_Id,info.Product_Name,convert_usd(price),"USD",price*10,"DEFAULT")
										if sdkName == "996SDK" then
											info.EXT = tostring(g_svrId)
											paySDK(info)
										elseif sdkName == "IOS_40407" then
											paySDK("http://cb.ttbsg.bwbbw.com/cb/40407/pay.php",info.Order_Id,info.Product_Name,info.Product_Price,info.Server_Id,"DEFAULT")
										elseif sdkName == "QUWANIOSSDK" then
											paySDK("http://cb.ttbsg.bwbbw.com/cb/quwanios/pay.php?",info.Order_Id,info.Product_Name,info.Product_Price,info.Server_Id,"DEFAULT")
										elseif sdkName == "DAMAIECSDK" then
											info.EXT = tostring(g_svrId)
											paySDK(info)
										elseif isYiJieSDK() then
    				                     	info.EXT = tostring(g_svrId)
    				                    	paySDK(info)
										elseif sdkName == "IOS996" then
											info.EXT = tostring(g_svrId)
    				                    	paySDK(info)
    				                    elseif is185() and not useNewSDKInterface then
    				                    	info.EXT = tostring(g_svrId)
    				                    	paySDK(info)
										elseif isQKQKDispathPackage_ttbsg and type(isQKQKDispathPackage_ttbsg) == "function" and isQKQKDispathPackage_ttbsg(getSDKName()) then

											local productId = lua_GetAppName().."."..tostring(price)
											local callbackUrl = "http://"..g_site.."cb/ttbsg_7k7kios/pay_appstore.php"

											paySDK(ret,tostring(price),tostring(productId),nil,tonumber(g_svrId),tonumber(g_player_info.utid),tostring(callbackUrl))

										else

											if useNewSDKInterface then
												local sdk = theSDK()
												info.Notify_Url = sdk:config().payCallback
												if sdk:config().requireSvrId then
													info.EXT = tostring(g_svrId)
												end
                                                						sdk:sdkPay(json.encode(info))
                                                						return
											end

											paySDK(info)
											
										end
									end
								else
									MyMessageBox(ls('获取信息失败，请重新尝试。'))
								end
                            else
                                FreePay()
							end

						elseif platform==kTargetWindows then
							FreePay()
						end
					end)()
				end
			end
		end
	end

	MainScene.onTouch=function ( event,x,y )
    	if event == "began" then
	        return onTouchBegan(x, y)
	    elseif event == "moved" then
	        return onTouchMoved(x, y)
	    else return MainScene.onTouchEnded(x, y)
	    end
    end

    local function loader()
		local  proxy = CCBProxy:create()
		local  node, animMgr  = CCBuilderReaderLoad("gamedata/ccb/main/vip_sc.ccbi",proxy,MainScene)
		local  layer = tolua.cast(node,"CCLayer")
		layer:setTouchEnabled(true)
		layer:registerScriptTouchHandler(MainScene.onTouch)
		layer:registerScriptHandler(MainScene.handler)
		--MainScene.item_str_count:setString("x"..gold)
		if getSDKName()~="huanyi_app" then
			MainScene.str_Pay:setString(price .. ls('元'))
			MainScene.str_Pay1:setString(price .. ls('元'))
		else
			MainScene.str_Pay:setString(convert_price(price) .. " NTD")
			MainScene.str_Pay1:setString(convert_price(price) .. " NTD")
			if getLocalePriceString ~= nil then
				local pstr = getLocalePriceString("com.morlia.hzsgz.g"..convert_price(price))
				if pstr ~= nil and pstr ~= "" then
					MainScene.str_Pay:setString(pstr)
					MainScene.str_Pay1:setString(pstr)
				end
			end
		end
		MainScene.vipBg1:setVisible(false)
		MainScene.vipBg2:setVisible(false)
		MainScene.vipBg3:setVisible(false)
		--MainScene.vip_icon1:setVisible(false)
		--MainScene.vip_icon2:setVisible(false)
		if info.monthCard then--月卡
			MainScene.vipBg1:setVisible(true)
			--MainScene.vip_icon1:setVisible(true)
			local str=""
			if g_player_info.yuekaDeadLine then
				str=getDayStr(g_player_info.yuekaDeadLine)
				str=str..ls('到期')
                if is7k7k() and g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,str),11))
				else
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc,str),11))
				end
			else
				if false and extraGold>0 then
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc .. ls('额外赠送%d元宝'),str,extraGold),11))
				else
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc ,str),11))
				end
			end
		elseif info.honourableCard then
			if g_player_info.zhizunkaTime==nil then
				MainScene.vipBg2:setVisible(true)
				--MainScene.vip_icon2:setVisible(true)
				if false and acInfo then
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc .. ls('额外赠送%d元宝'),extraGold),11))
				else
					MainScene.str_info:setString(addNewLine(info.firstDesc,11))
				end

			else
				MainScene.vipBg3:setVisible(true)
				if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,extraGold),11))
				else
					if false and acInfo then
						MainScene.str_info:setString(addNewLine(string.format(ls('购买获得600元宝，首次购买再送600元宝！额外赠送%d元宝'),extraGold),11))
					else
						MainScene.str_info:setString(addNewLine(ls('购买获得600元宝，首次购买再送600元宝！'),11))
					end
				end
			end

		else
			MainScene.vipBg3:setVisible(true)
			if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
				MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,extraGold),11))
			else
				if false and acInfo then
					MainScene.str_info:setString(addNewLine(string.format(info.firstDesc .. ls('额外赠送%d元宝'),extraGold),11))
				else
					MainScene.str_info:setString(addNewLine(info.firstDesc,11))
				end
			end

		end
		if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
			MainScene.first:setVisible(false)
		elseif is7k7k() then

			MainScene.txt:setString(ls('首冲十倍'))
			
		end
		if acInfo and g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
			MainScene.exGold:setVisible(true)
		end
		MainScene.layer=layer
		return MainScene
	end

	return loader()
end
