require "gamedata/lua/common"
require "gamedata/lua/main/vip_sc2"
require "gamedata/lua/items/box"
require "gamedata/lua/stb/stb_opt"

function vip_scX_main(parentScene,info)
	local MainScene = {}
	local price=info.recharge
	local gold=info.recharge*10
	local curScene
    MainScene.handler = function(event)
        if event == "enter" then
        	-- OnEnter
			--MainScene.layer:scheduleUpdateWithPriorityLua(MainScene.updateScroll,0)
			curScene=CCDirector:sharedDirector():getRunningScene()
        end
    end
	local ptTouchBegan
	local scrollRect=CCRect(75,115,810,385)
	local rect=CCRect(0,0,390,150)
	local function onTouchBegan( x,y )
		if not parentScene.buy:isVisible() then
			return false
		end
		ptTouchBegan=ccp(x,y)
		return true
	end
	local function onTouchMoved( x,y )
		-- body
	end

	local function FreePay()
		local ret=net.rpc("vip.charge",price)
		if type(ret)=="table" then
			if _G.next(g_player_info.chargeInfo)==nil then
				addRedtip(GameMainScene.mainMainScene.gift)
				g_red_tip_first_charge=true
				if not g_localPlayer.goldEquipWizard then
					addArrows(GameMainScene.mainMainScene.gift)
				end
			end
			g_player_info.gold=ret.g
			g_player_info.chargedGold=ret.c
			g_player_info.chargeInfo[price]=ret.cnt
			MainScene.first:setVisible(false)
			MainScene.three:setVisible(false)
			MainScene.five:setVisible(false)
			MainScene.ten:setVisible(false)
			if not g_player_info.chargeInfo[price] or g_player_info.chargeInfo[price]==0 then
			if info.monthCard or info.honourableCard then
					MainScene.five:setVisible(true)
				else
					MainScene.ten:setVisible(true)
				end
			else
				MainScene.three:setVisible(true)
			end
			parentScene.updateVipLevelInfo()
			popup_main(ls('充值成功'))
			if info.monthCard then--月卡
				g_player_info.yuekaDeadLine=ret.yuekaTime
				local str=""
				if g_player_info.yuekaDeadLine then
					str=getDayStr(g_player_info.yuekaDeadLine)
					str=str..ls('到期')				end
				MainScene.str_info:setString(addNewLine(string.format(info.firstDesc,str),11))
			elseif info.honourableCard then
				if g_player_info.chargeInfo[price]==1 then--第一次充值至尊卡
					parentScene.initRecharge()
				else
					MainScene.str_info:setString(addNewLine(info.normalDesc,11))
				end
			else
				if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(info.normalDesc,11))
				else
					MainScene.str_info:setString(addNewLine(info.firstDesc,11))
				end
			end
		else
			popup_main(ls('出错'))
		end
	end

	MainScene.onTouchEnded = function( x,y )	
		if stb_opt.isStbOpt or math.pow(ptTouchBegan.x-x,2)+math.pow(ptTouchBegan.y-y,2)<math.pow(g_slidePixels,2) then
			local tp=curScene:convertToNodeSpace(ccp(x,y))
			if scrollRect:containsPoint(tp) then
				local tp=MainScene.layer:convertToNodeSpace(ccp(x,y))
				if rect:containsPoint(tp) then
					--if false then
						--return popup_main(ls('封测期间充值系统暂不开放，谢谢'),nil,8)
					--end
					
					local pName=price *10 .. ls('元宝')					if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
						pName=price *10 .. "yuanbao"
					end
					if g_is185sy then
						pName=price *10*g_chongzhiMulti .. ls('元宝')
					end
					local check_str=""
					if info.monthCard then--月卡
						pName=ls('月卡')						if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
							pName="yueka"
						end
						check_str=ls('确定充值%s元购买月卡？',price)					elseif info.honourableCard and (g_player_info.chargeInfo[price]==nil or g_player_info.chargeInfo[price]==0)then
						check_str=ls('确定充值%s元购买至尊卡？',price)						pName=ls('至尊卡')						if g_anysdk_agent and g_anysdk_agent:getChannelId()=="500002" then --同步推
							pName="zhizunka"
						end
					else
						check_str=ls('确定充值%s元？',price)					end
					checkBox(check_str,coFunc(function ()

						local platform=CCApplication:sharedApplication():getTargetPlatform()

						local sdkName=getSDKName()
						if sdkName==nil or sdkName=="test" or sdkName =="IOS" then --测试服，元宝随意冲
							FreePay()
						elseif sdkName == "weilan" or sdkName == "appstore" then
							local rate = 1
							local ret=net.rpc("vip.getOrderId",price)
							cclog("order_id:",ret or "nil")
							if type(ret)=="string" then
								if ret=="cnt" or ret=="failed" or ret=="time" then
									MyMessageBox(ls('获取信息失败，请重新尝试。'))
								else
									local info = {
										Order_Id=ret,
										Product_Price=tostring(price*rate), 
										Transaction_Num="10",
										Product_Id=tostring(price),  
										Product_Name=pName,    
										Role_Id=tostring(g_player_info.utid),  
										Role_Name=g_player_info.name,
										Notify_Url="",
										EXT="",
										Server_Id=tostring(0),  
										Product_Count="1",
										Role_Grade=tostring(g_player_info.level),
										Role_Balance=tostring(g_player_info.gold)
									   }
									paySDK(info)
								end
							end
						elseif kTargetAndroid==platform or kTargetIphone==platform or kTargetIpad==platform then
							cclog("vip_sc:kTargetAndroid")
							if g_anysdk_agent then
								cclog("g_anysdk_agent")
								local iap_plugin_maps = g_anysdk_agent:getIAPPlugin()
								local function onResult( code, msg, info )   --code: pay result code, msg: par result message, info: product info.
								   cclog("pay result----")
									if msg then
										cclog("pay result----:" ..msg)
									end
								   if code == PayResultCode.kPaySuccess  then
									   cclog("PayResultCode.kPaySuccess")
										--popup_main("充值成功！")
									elseif code == PayResultCode.kPayNowPaying then
										cclog("PayResultCode.kPayNowPaying")
										ProtocolIAP:resetPayState()
								   end
							   end
							
							   for key, value in pairs(iap_plugin_maps) do
								   cclog("key:" .. key)
								   cclog("value: " .. type(value))
								   value:setResultListener(onResult)
							   end
								local pId=tostring(price)
								if "000016"==g_anysdk_agent:getChannelId() then --联想
									pId="3647"
								elseif "000009"==g_anysdk_agent:getChannelId() or "000078"==g_anysdk_agent:getChannelId() then --应用汇/酷派
									pId="1"
								elseif "160002"==g_anysdk_agent:getChannelId() then --爱贝
									local t={}
									t[6]=3
									t[60]=2
									t[25]=1
									t[198]=7
									t[128]=6
									t[98]=5
									t[30]=4
									t[648]=9
									t[328]=8
									pId=tostring(t[price])
								end
								local info = {
								   Product_Price=tostring(price), 
								   Product_Id=pId,  
								   Product_Name=pName,  
								   Server_Id=tostring(g_svrId),  
								   Product_Count="1",  
								   Role_Id=tostring(g_player_info.utid),  
								   Role_Name=g_player_info.name,
								   Role_Grade=tostring(g_player_info.level),
								   Role_Balance=tostring(g_player_info.gold)
							   }
								if g_anysdk_agent:getChannelId()=="000020" then
									info.Product_Name=ls('个').. info.Product_Name
								end
								for key, value in pairs(iap_plugin_maps) do
									cclog("key:" .. key)
									value:payForProduct(info)
									break
								end
							elseif g_initSDK then
								cclog("g_initSDK")
								local ret=net.rpc("vip.getOrderId",price)
								cclog("order_id:",ret or "nil")
								if type(ret)=="string" then
									if ret=="cnt" or ret=="failed" or ret=="time" then
										MyMessageBox(ls('获取信息失败，请重新尝试。'))
									else
										--MyMessageBox(ret)
										local payurl=""
										local rate=1
										local sdkName=getSDKName()
										if sdkName=="QIHOO_SDK" then
											rate=100
											payurl="http://123.57.191.96/cb/qihoo/pay_callback.php"
										elseif sdkName=="UC_SDK" then
											rate=1
											payurl="http://123.57.191.96/cb/uc/PayCallbackServer.php"
										elseif sdkName=="LETVSDK" then
											payurl="http://123.57.191.96/cb/leshi/pay.php"
										end
										
										local info = {
											Order_Id=ret,
											Product_Price=tostring(price*rate), 
											Transaction_Num="10",
											Product_Id=tostring(price),  
											Product_Name=pName,    
											Role_Id=tostring(g_player_info.utid),  
											Role_Name=g_player_info.name,
											Notify_Url=payurl,
											EXT="",
											Server_Id=tostring(0),  
											Product_Count="1",
											Role_Grade=tostring(g_player_info.level),
											Role_Balance=tostring(g_player_info.gold)
									   }
										if sdkName == "MGSDK" or sdkName == "LLSDK" or sdkName == "MOLISDK" then
											info.EXT=tostring(g_svrId)
										end
										if sdkName == "LQLQSSDK" then
											info.Role_Id = tostring(g_svrId)
										end
										if isYiJieSDK() then
    				                     	info.EXT = tostring(g_svrId)
    				                    end
										paySDK(info)
									end
								else
									MyMessageBox(ls('获取信息失败，请重新尝试。'))
								end
                            else
                                FreePay()
							end
							
						elseif platform==kTargetWindows then
							FreePay()
						end
					end))
				end
			end
		end
	end
	
	MainScene.onTouch=function ( event,x,y )
    	if event == "began" then
	        return onTouchBegan(x, y)
	    elseif event == "moved" then
	        return onTouchMoved(x, y)
	else return MainScene.onTouchEnded(x,y)
	    end
    end
	
    local function loader()
		local  proxy = CCBProxy:create()
		local  node, animMgr  = CCBuilderReaderLoad("gamedata/ccb/main/vip_scX.ccbi",proxy,MainScene)
		local  layer = tolua.cast(node,"CCLayer")
		layer:setTouchEnabled(true)
		layer:registerScriptTouchHandler(MainScene.onTouch)
		layer:registerScriptHandler(MainScene.handler)
		--MainScene.item_str_count:setString("x"..gold)
		MainScene.str_Pay:setString(price .. ls('元'))
		MainScene.vipBg1:setVisible(false)
		MainScene.vipBg2:setVisible(false)
		MainScene.vip_icon1:setVisible(false)
		MainScene.vip_icon2:setVisible(false)
		if info.monthCard then--月卡
			MainScene.vipBg1:setVisible(true)
			MainScene.vip_icon1:setVisible(true)
			local str=""
			if g_player_info.yuekaDeadLine then
				str=getDayStr(g_player_info.yuekaDeadLine)
				str=str..ls('到期')			end
			if not g_player_info.chargeInfo[price] or g_player_info.chargeInfo[price]==0 then
				MainScene.str_info:setString(addNewLine(string.format(info.firstDesc,str),11))
			else
				MainScene.str_info:setString(addNewLine(string.format(info.normalDesc,str),11))
			end
			
		elseif info.honourableCard and g_player_info.chargeInfo[price]==nil then
			if not g_player_info.zhizunkaTime then
				MainScene.vipBg2:setVisible(true)
				MainScene.vip_icon2:setVisible(true)
				MainScene.str_info:setString(addNewLine(info.firstDesc,11))
			else
				if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
					MainScene.str_info:setString(addNewLine(info.normalDesc,11))
				else
					MainScene.str_info:setString(addNewLine(ls('首次购买获得3000元宝！'),11))
				end
			end
			
		else
			if g_player_info.chargeInfo[price] and g_player_info.chargeInfo[price]>0 then
				MainScene.str_info:setString(addNewLine(info.normalDesc,11))
			else
				MainScene.str_info:setString(addNewLine(info.firstDesc,11))
			end
			
		end
		MainScene.first:setVisible(false)
		MainScene.three:setVisible(false)
		MainScene.five:setVisible(false)
		MainScene.ten:setVisible(false)
		if not g_player_info.chargeInfo[price] or g_player_info.chargeInfo[price]==0 then
			if info.monthCard or info.honourableCard then
				MainScene.five:setVisible(true)
			else
				MainScene.ten:setVisible(true)
			end
		else
			MainScene.three:setVisible(true)
		end
		MainScene.layer=layer
		return MainScene
	end
		
	return loader()
end